#!/bin/bash -e

. ../../gsc_environment/build_funcs.sh  $*

./configure ${CONFIGURE_FLAGS} \
    --disable-static \
    --disable-ssh \
    --enable-ipv6 \
    --disable-dict \
    --disable-file \
    --disable-smb \
    --enable-ftp \
    --enable-ftps \
    --disable-gopher \
    --disable-imap \
    --enable-lber \
    --enable-ldap \
    --enable-ldaps \
    --disable-imaps \
    --disable-pop3 \
    --disable-pop3s \
    --disable-rtsp \
    --enable-smtp \
    --enable-smtps \
    --disable-telnet \
    --enable-tftp \
    --enable-ares \
    --disable-manual \
    CFLAGS="${CFLAGS} -Wextra -Wl,-z,relro,-z,now -Wall -Wformat-security" \
    CXXFLAGS="${CFLAGS} -Wextra -Wl,-z,relro,-z,now -Wall -Wformat-security"
#    CFLAGS="${CFLAGS} -Wextra -Wl,-z,relro,-z,now,-rpath=${TOOLCHAIN_LIB_DIR} -Wall -Wformat-security" \
#    CXXFLAGS="${CFLAGS} -Wextra -Wl,-z,relro,-z,now,-rpath=${TOOLCHAIN_LIB_DIR} -Wall -Wformat-security"

check_status
make  
check_status

[ -d ".install" ] && rm -rf .install
mkdir .install

make DESTDIR=$(pwd)/.install install
check_status

echo ${TOOLCHAIN_INCLUDE_DIR} ${TOOLCHAIN_LIB_DIR} 
cp -av .install/usr/local/include/* ${TOOLCHAIN_INCLUDE_DIR}/
cp -av .install/usr/local/lib/* ${TOOLCHAIN_LIB_DIR}/
ccd .install/usr/local/lib/lib*so* ${IMAGE_BUILD}/packages/files/curl/${ARCH}/usr/lib/
ccd .install/usr/local/bin/curl ${IMAGE_BUILD}/packages/files/curl/${ARCH}/usr/bin/

