#!/bin/bash

. ../../gsc_environment/build_funcs.sh $1

export CC=${CROSS_PREFIX}gcc
export AR=${CROSS_PREFIX}ar
export LD=${CROSS_PREFIX}ld
export STRIP=${CROSS_PREFIX}strip

CONFIGURE_SETTINGS="--enable-debug=no --disable-xml-docs --disable-asserts --disable-doxygen-docs --disable-ducktype-docs --disable-selinux --disable-apparmor--disable-libaudit --enable-inotify"
CONFIGURE_SETTINGS="$CONFIGURE_SETTINGS --disable-kqueue --disable-console-owner-file --disable-launchd --disable-systemd --disable-embedded-tests --disable-modular-tests --disable-tests"
CONFIGURE_SETTINGS="$CONFIGURE_SETTINGS --disable-installed-tests --disable-code-coverage --disable-epoll --disable-x11-autolaunch --disable-stats --disable-user-session --disable-containers"
CONFIGURE_SETTINGS="$CONFIGURE_SETTINGS --disable-verbose-mode --disable-maintainer-mode --disable-developer --disable-static --without-x"
CONFIGURE_SETTINGS="$CONFIGURE_SETTINGS --with-session-socket-dir=/tmp --with-system-socket=/var/run/dbus/system_bus_socket --with-system-pid-file=/var/run/dbus.pid --with-dbus-user=root"
CONFIGURE_SETTINGS="$CONFIGURE_SETTINGS --with-dbus-daemondir=/usr/bin --localstatedir=/var"



./configure $CONFIGURE_FLAGS CFLAGS="-Os" $CONFIGURE_SETTINGS --prefix=/usr
make clean
rm -rf .install
make -j9
check_status

mkdir -p ./install
make install DESTDIR="$PWD/.install"

find .install/ -name "*.la" -delete
$STRIP --strip-unneeded .install/usr/lib/*.so*
$STRIP --strip-unneeded .install/usr/bin/*

# image_build
mkdir -p ${IMAGE_BUILD}packages/files/dbus/${ARCH}/usr/lib${ARCH_BITS}
cp -av .install/usr/lib/libdbus*.so* ${IMAGE_BUILD}packages/files/dbus/${ARCH}/usr/lib${ARCH_BITS}/
mkdir -p ${IMAGE_BUILD}packages/files/dbus/${ARCH}/usr/bin
cp -av .install/usr/bin/* ${IMAGE_BUILD}packages/files/dbus/${ARCH}/usr/bin
mkdir -p ${IMAGE_BUILD}packages/files/dbus/common/usr
cp -av .install/usr/var ${IMAGE_BUILD}packages/files/dbus/common/usr/
mkdir -p ${IMAGE_BUILD}packages/files/dbus/common/usr/share
cp -av .install/usr/share/dbus-1 ${IMAGE_BUILD}packages/files/dbus/common/usr/share/mkdir -p ${IMAGE_BUILD}packages/files/dbus/common/usr/share

# toolchain
cp -av .install/usr/lib/* ${TOOLCHAIN_LIB_DIR}
cp -av .install/usr/include/* ${TOOLCHAIN_INCLUDE_DIR}
