#!/bin/bash -e

. ../../gsc_environment/build_funcs.sh $1

export CC=${CROSS_PREFIX}gcc
export AR=${CROSS_PREFIX}ar
export LD=${CROSS_PREFIX}ld
export STRIP=${CROSS_PREFIX}strip

./configure --prefix=/usr $CONFIGURE_FLAGS CFLAGS="-Os" --enable-static --enable-static --without-docbook --without-xmlwf
rm -rf .install
make clean
make -j9
check_status

mkdir -p ./install
make install DESTDIR="$PWD/.install"

find .install/ -name "*.la" -delete
$STRIP --strip-unneeded .install/usr/lib/libexpat.a .install/usr/lib/libexpat*.so*

# image_build
mkdir -p ${IMAGE_BUILD}packages/files/expat/${ARCH}/usr/lib${ARCH_BITS}
cp -av .install/usr/lib/libexpat.so* ${IMAGE_BUILD}packages/files/expat/${ARCH}/usr/lib${ARCH_BITS}/

# toolchain
cp -av .install/usr/lib/* ${TOOLCHAIN_LIB_DIR}
cp -av .install/usr/include/* ${TOOLCHAIN_INCLUDE_DIR}
