#!/bin/bash -e

. ../../gsc_environment/build_funcs.sh $1

./autogen.sh
./configure ${CONFIGURE_FLAGS} CFLAGS="${CFLAGS} -Wextra -Wl,-z,relro,-z,now -Wall -Wformat-security"
make clean
make V=1
check_status

if [ -d installation ]; then
    rm -r installation
fi
make install DESTDIR="`pwd`/installation"
check_status

# image_build
ccd installation/usr/local/lib/libjson-c.so* ${IMAGE_BUILD}packages/files/json-c/${ARCH}/usr/lib${ARCH_BITS}/

# toolchain
ccd installation/usr/local/lib/libjson-c.so* ${TOOLCHAIN_LIB_DIR}
ccd installation/usr/local/lib/pkgconfig/json-c.pc ${TOOLCHAIN_LIB_DIR}/pkgconfig
ccd installation/usr/local/include/json-c/* ${TOOLCHAIN_INCLUDE_DIR}/json-c
