#include <linux/module.h>     //ֶ֧̬Ӻжģ
#include <linux/kernel.h>    //Ҫдںˣںصͷļ
#include <linux/init.h>      //ʼͷļ

#include <linux/fs.h>        //ļstructĶ
#include <linux/types.h>     //һЩ͵Ķ
#include <linux/fcntl.h>     //ļõغ
#include <linux/vmalloc.h>  //vmalloc()ڴַַ
#include <linux/blkdev.h>  //requestʽ 豸Ҫblk_init_queue 
#include <linux/hdreg.h> //Ӳ̲ͷļӲ̼Ĵ˿ڡ״̬ͷϢ
#include <mach/map.h>

#define RAMHD_NAME              "video_ram"    //豸
#define RAMHD_MAX_DEVICE        1           //豸
#define RAMHD_MAX_PARTITIONS    1           //

#define RAMHD_SECTOR_SIZE       512        //С
#define RAMHD_SECTORS           16         //  http://www.embedu.org/Column/Column863.htm
#define RAMHD_HEADS             4         //ͷ
#define RAMHD_CYLINDERS         256      //ŵ() 

#define RAMHD_SECTOR_TOTAL      (RAMHD_SECTORS * RAMHD_HEADS * RAMHD_CYLINDERS)  //ܴС
#define RAMHD_SIZE              (RAMHD_SECTOR_SIZE * RAMHD_SECTOR_TOTAL) //8MB

typedef struct{
    unsigned char   *data;             //豸ݿռ׵ַ
    struct request_queue *queue;       //豸
    spinlock_t      lock;             //
    struct gendisk  *gd;              //ͨô̽ṹ
}RAMHD_DEV;

static char *sdisk[RAMHD_MAX_DEVICE];  //ڴ׵ַ
static RAMHD_DEV *rdev[RAMHD_MAX_DEVICE];  //ڴ׵ַ

static dev_t ramhd_major;   //豸

static unsigned long disk_addr = AK_PA_VIDEO_BUFF;
static unsigned long disk_size = AK_SZ_VIDEO_BUFF;

module_param(disk_addr, ulong, S_IRUGO);
module_param(disk_size, ulong, S_IRUGO);

static int ramhd_space_init(void)
{
    int i;
    int err = 0;
    for(i = 0; i < RAMHD_MAX_DEVICE; i++){
        sdisk[i] = ioremap(disk_addr, disk_size);
        if(!sdisk[i]){
            err = -ENOMEM;  //errno:12 ڴ治
            return err;
        }
		memset(sdisk[i], 0, disk_size);
    }

    return err;
}

static void ramhd_space_clean(void)
{
    int i;
    for(i = 0; i < RAMHD_MAX_DEVICE; i++){
        iounmap((void*)disk_addr);
    }
}

static int alloc_ramdev(void)
{
    int i;
    for(i = 0; i < RAMHD_MAX_DEVICE; i++){
        rdev[i] = kzalloc(sizeof(RAMHD_DEV), GFP_KERNEL); //ںRAMHD_DEVṹڴռ
        if(!rdev[i])
            return -ENOMEM;   //errno:12  ڴ治
    }
    return 0;
}

static void clean_ramdev(void)
{
    int i;
    for(i = 0; i < RAMHD_MAX_DEVICE; i++){
        if(rdev[i])
            kfree(rdev[i]);   //ͷŷڴ
    }   
}       

int ramhd_open(struct block_device *bdev, fmode_t mode)   //豸õ
{   
    return 0;
}

int ramhd_release(struct gendisk *gd, fmode_t mode)   //豸رõ
{   
    return 0;
}

static int ramhd_ioctl(struct block_device *bdev, fmode_t mode, unsigned int cmd, unsigned long arg) //IO
{
    int err;
    struct hd_geometry geo;  //hd_geometryṹͷϢ

    switch(cmd)
    {
        case HDIO_GETGEO:  //ȡ豸 
            err = !access_ok(VERIFY_WRITE, arg, sizeof(geo));//ָָĴ洢Ƿд
            if(err) return -EFAULT;     //errno:14   ַ 
        
            geo.cylinders = RAMHD_CYLINDERS;     //
            geo.heads = RAMHD_HEADS;            //ͷ
            geo.sectors = RAMHD_SECTORS;        //
            geo.start = get_start_sect(bdev);   //ʼַ
            if(copy_to_user((void *)arg, &geo, sizeof(geo)))
             //ں˵ַ&geoָʾݸƵargָûռĵַ
                return -EFAULT;   //errno:14   ַ 
            return 0;
    }
            
    return -ENOTTY;      //errno:25     ʵIOƲ 
}

static struct block_device_operations ramhd_fops =  //һ豸Ĳ
{   
	.owner = THIS_MODULE,
    .open = ramhd_open,
    .release = ramhd_release,
    .ioctl = ramhd_ioctl,
};

void ramhd_req_func (struct request_queue *q)  //ݸ豸
{
    struct request *req;  //ȡreq
	RAMHD_DEV *pdev;
	char *pData;
	unsigned long addr, size, start;
	req = blk_fetch_request(q); //ӿ豸ȡ洢req;
        //blk_fetch_request()ԶεãqueueûݣreqNULL
	while (req) {   //жϵǰrequestǷϷ  ѭлȡһҪ
		start = blk_rq_pos(req); // ȡǰrequestṹʼ 
		pdev = (RAMHD_DEV *)req->rq_disk->private_data; //豸ṹָ
		pData = pdev->data;//豸ַ
		addr = (unsigned long)pData + start * RAMHD_SECTOR_SIZE;//ַ
        size = blk_rq_cur_bytes(req); // req һ
		if (rq_data_dir(req) == READ) //ݴͷ.0ʾ豸ȡ,ʾд豸.
			memcpy(req->buffer, (char *)addr, size); //
		else
			memcpy((char *)addr, req->buffer, size); //д
	
		if(!__blk_end_request_cur(req, 0))  //귵false
			req = blk_fetch_request(q);  //ȡе
	}
}

int ramhd_init(void)   //ʼ
{
    int i;
	int ret;

	if((disk_addr < 0x80000000) || ((disk_addr + disk_size)  > (0x80000000 + AK_SZ_VIDEO_BUFF))){
		printk(KERN_ERR "###error!\n");
		printk(KERN_ERR "disk_addr + disk_size must :0x80000000 - %x!\n", 0x80000000 + AK_SZ_VIDEO_BUFF);
		return -1;
	}
	
    ret = ramhd_space_init();
	if(ret < 0){
		printk(KERN_ERR "###ramhd_space_init fail!\n");
		return -1;
	}
	
    ret = alloc_ramdev();
	if(ret < 0){
		printk(KERN_ERR "###alloc_ramdev fail!\n");
		return -1;
	}
    
    ramhd_major = register_blkdev(0, RAMHD_NAME); //豸עᵽں
    //majorΪ0ں˻Զһµ豸ţramhd_major   
    for(i = 0; i < RAMHD_MAX_DEVICE; i++)
    {
        rdev[i]->data = sdisk[i]; 
        rdev[i]->gd = alloc_disk(RAMHD_MAX_PARTITIONS);
        spin_lock_init(&rdev[i]->lock);  //ʼ
        rdev[i]->queue = blk_init_queue(ramhd_req_func, &rdev[i]->lock);//ʼramhd_req_funcа
        rdev[i]->gd->major = ramhd_major; 
        rdev[i]->gd->first_minor = i * RAMHD_MAX_PARTITIONS;
        rdev[i]->gd->fops = &ramhd_fops;  //豸ķ
        rdev[i]->gd->queue = rdev[i]->queue;
        rdev[i]->gd->private_data = rdev[i]; //ʹԱָ
        sprintf(rdev[i]->gd->disk_name, "video_ram%d", i);
        //set_capacity(rdev[i]->gd, RAMHD_SECTOR_TOTAL);
        set_capacity(rdev[i]->gd, disk_size/RAMHD_SECTOR_SIZE);
        add_disk(rdev[i]->gd);   //ϵͳ豸
    }
        
    return 0;
}

void ramhd_exit(void)  //ģжغ
{
    int i;
    for(i = 0; i < RAMHD_MAX_DEVICE; i++)
    {
        del_gendisk(rdev[i]->gd); //ɾgendiskṹ   
        put_disk(rdev[i]->gd);   //gendiskṹü
        blk_cleanup_queue(rdev[i]->queue);  //
    }
    unregister_blkdev(ramhd_major,RAMHD_NAME); ; //ע豸 
    clean_ramdev();
    ramhd_space_clean();  
}

module_init(ramhd_init);
module_exit(ramhd_exit);


MODULE_AUTHOR("lyl");
MODULE_DESCRIPTION("The Ramdisk implementation with request function");
MODULE_LICENSE("GPL");
