#!/bin/bash

make clean
[ -f Makefile ] && rm -f Makefile

. ../../gsc_environment/build_funcs.sh $*
	
./configure ${CONFIGURE_FLAGS} \
    --with-privsep-user=root --with-privsep-group=root --with-privsep-chroot=/  \
    LIBS=-ldl CFLAGS=-DGXP

make V=99

if [ "$?" == "0" ]; then
    echo "Build successful!"
    TARGET=${IMAGE_BUILD}/packages/files/lldpd/${ARCH}/
    [ -d ${TARGET}/usr/sbin ] || mkdir -p ${TARGET}/usr/sbin

    echo "Copying lldp and lldpctl files to image_build folders..."
    cp -vf ./src/lldpd ${TARGET}/usr/sbin/
    cp -vf ./src/lldpctl ${TARGET}/usr/sbin/
else
    echo "Build fails!"
fi
