
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>

#include "nvram.h"
#include "syslog.h"


syslog_config_t g_syslog_conf = {0};


int syslog_get_config(void)
{
	char *p; 

	memset(&g_syslog_conf, 0, sizeof(g_syslog_conf));
	
	p = nvram_get(P_SYSLOG_SERVER);
	if( p != NULL ){
		memcpy(g_syslog_conf.server, p, strlen(p));
		g_syslog_conf.enable = 1; 
	}else{
		g_syslog_conf.enable = 0; 
	}

	p = nvram_get(P_SYSLOG_LEVEL);
	if( p != NULL ){
		g_syslog_conf.level = atoi(p);
		//g_syslog_conf.level = 2; //*DEBUG
	}
	printf("nvram_get( %s ) \n", P_SYSLOG_ID);
	p = nvram_get( P_SYSLOG_ID );

	if ( p != NULL )
	{
		printf("nvram_get( %s ) = %s \n", P_SYSLOG_ID, p);
		memcpy( g_syslog_conf.syslog_id, p, strlen( p ) );
	}
	else
	{
		
		sprintf(g_syslog_conf.syslog_id, "GSC36xx[%s][%s]", nvram_get("P67"), nvram_get("P68"));
		printf("nvram_get( %s ) is NULL, SET TO %s \n", P_SYSLOG_ID, g_syslog_conf.syslog_id);	
	}
  
	printf("SyslogConf: \n"
		"Server: %s \n"
		"enable: %d \n"
		"level: %d \n"
		"syslog_id: %s \n"
		, 
		g_syslog_conf.server,
		g_syslog_conf.enable , 
		g_syslog_conf.level,
		g_syslog_conf.syslog_id
		
		);
	return 0; 
}

int syslog_level_check(
	int	level
)
{
	return 0; 
}

int syslog_init(
		char *tsk_name //* 
)
{
	if( tsk_name == NULL ){
		printf("Please input task name \n");
		return -1; 
	}
	
	syslog_get_config();
	
	switch(g_syslog_conf.level)
	{
		case 1:
			setlogmask (LOG_UPTO (LOG_DEBUG));
			g_syslog_conf.log_level = LOG_DEBUG;
			break;
			
		case 2:
			setlogmask (LOG_MASK (LOG_INFO));
			g_syslog_conf.log_level = LOG_INFO;
			break;
			
		case 3:
			setlogmask (LOG_MASK (LOG_WARNING));
			g_syslog_conf.log_level = LOG_WARNING;
			break;
			
		case 4:
			setlogmask (LOG_MASK (LOG_ERR));
			g_syslog_conf.log_level = LOG_ERR;
			break;
			
		default:
			return(0);
	}
	openlog( g_syslog_conf.syslog_id,  LOG_NDELAY | LOG_PERROR, LOG_LOCAL1 );
	strcpy(g_syslog_conf.name, tsk_name);
	DEBUG(LOG_DEBUG, "%s open syslog success ! \n", tsk_name);
	printf("%s open syslog success \n", tsk_name);
	return 0; 
}

int syslog_exit(void)
{
	closelog();
	return 0; 
}



