#ifndef __GS_SYSLOG_H__
#define __GS_SYSLOG_H__


#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>
#include <sys/syslog.h>


#define __FONLY__  strrchr(__FILE__,'/')?strrchr(__FILE__,'/')+1:__FILE__
#define P_SYSLOG_SERVER                   "207"
#define P_SYSLOG_LEVEL                    "208"
#define P_SYSLOG_ID                    		"syslog_id"

typedef struct syslog_config_s{
	int					enable; 
	int					level; 
	int					log_level;
	char				name[64];
	unsigned char		server[128];
	unsigned char       syslog_id[128];
}syslog_config_t;

int syslog_init(
		char *tsk_name //* 
);
int syslog_exit(void);


extern syslog_config_t g_syslog_conf;

#define DEBUG(level, fmt, args...)	{\
	char logLevel[14];\
	memset( logLevel, 0, sizeof( logLevel ) );\
	switch ( level )\
	{\
	 case LOG_INFO:\
		 snprintf( logLevel, sizeof( logLevel ), "USER.INFO    ");\
		 break;\
	 case LOG_WARNING:\
		 snprintf( logLevel, sizeof( logLevel ), "USER.WARNING ");\
		 break;\
	 case LOG_ERR:\
		 snprintf( logLevel, sizeof( logLevel ), "USER.ERROR   ");\
		 break;\
	 case LOG_DEBUG:\
		 snprintf( logLevel, sizeof( logLevel ), "USER.DEBUG   ");\
		 break;\
	 default:\
		 snprintf( logLevel, sizeof( logLevel ), "USER.NONE   ");\
		 break;\
	}\
     if( g_syslog_conf.enable == 1 ){\
        syslog(level, "%s[%s]%s:%s():%i:" fmt, logLevel, g_syslog_conf.name, \
        __FONLY__,__FUNCTION__, __LINE__, ## args); \
     }else{\
		printf("%s[%s]%s:%s():%i:" fmt, logLevel, g_syslog_conf.name,__FONLY__, \
                 __FUNCTION__, __LINE__, ## args); }\
 }

#endif /* __GS_SYSLOG_H__ */  

