#!/bin/bash -e

. ../../gsc_environment/build_funcs.sh $1

if [ -d installation ]; then
    rm -rf installation
fi

./Configure linux-generic32 shared --prefix=$INSTALL_DIR --openssldir=/usr/lib/openssl --install_prefix="`pwd`/installation"
make clean
make
make install
check_status

# image_build
ccd installation/usr/lib/openssl/lib/libssl.so* ${IMAGE_BUILD}packages/files/openssl/${ARCH}/usr/lib${ARCH_BITS}/
ccd installation/usr/lib/openssl/lib/libcrypto.so* ${IMAGE_BUILD}packages/files/openssl/${ARCH}/usr/lib${ARCH_BITS}/
ccd installation/usr/lib/openssl/lib/engines/*so ${IMAGE_BUILD}packages/files/openssl/${ARCH}/usr/lib${ARCH_BITS}/ssl/engines/
ccd installation/usr/lib/openssl/bin/openssl ${IMAGE_BUILD}packages/files/openssl/${ARCH}/usr/bin/

# toolchain
ccd installation/usr/lib/openssl/lib/libssl.a ${TOOLCHAIN_LIB_DIR}
ccd installation/usr/lib/openssl/lib/libssl.so* ${TOOLCHAIN_LIB_DIR}
ccd installation/usr/lib/openssl/lib/libcrypto.a ${TOOLCHAIN_LIB_DIR}
ccd installation/usr/lib/openssl/lib/libcrypto.so* ${TOOLCHAIN_LIB_DIR}
ccd installation/usr/lib/openssl/include/openssl/* ${TOOLCHAIN_INCLUDE_DIR}/openssl/
