/****************************************************************************
 *
 * Copyright (c) 2019 by Grandstream Networks, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 *
 ***************************************************************************/

//=======================
//  Includes
//=======================
#include <common.h>
#include <gs_rsa/gs_rsa.h>

//=======================
//  Defines
//=======================

//=======================
//  Globals
//=======================

#if defined( CONFIG_GSC36XX )
struct gs_pubkey_t gs_public_key =
{
	.n = {
		0xbd, 0xf7, 0x02, 0xf4, 0xea, 0x36, 0x9f, 0x16, 
		0x92, 0x09, 0x86, 0x0a, 0x54, 0x2e, 0x7a, 0xec, 
		0x17, 0x0d, 0x49, 0xa1, 0x0e, 0x82, 0x9d, 0x68, 
		0x10, 0x4b, 0x17, 0xec, 0x84, 0x26, 0xff, 0xb3, 
		0xa4, 0x49, 0xaa, 0x54, 0x2f, 0xe6, 0xa2, 0xb5, 
		0xf8, 0x06, 0x7c, 0xd7, 0x36, 0xe8, 0x9d, 0x3a, 
		0x13, 0xb9, 0xbd, 0x53, 0x96, 0x57, 0xf9, 0xb7, 
		0x5e, 0x54, 0x24, 0xbf, 0x52, 0xea, 0x10, 0x15, 
		0xa0, 0xc0, 0x01, 0xb5, 0xd3, 0xf0, 0x90, 0x1e, 
		0xd4, 0xf6, 0x96, 0x80, 0xf5, 0x17, 0x98, 0xa1, 
		0xf1, 0x10, 0xe5, 0xd6, 0xaf, 0xa0, 0xad, 0xf1, 
		0x78, 0x97, 0x22, 0x10, 0x35, 0xb7, 0x8d, 0x26, 
		0xaa, 0x87, 0xb5, 0x47, 0x23, 0xd1, 0xf5, 0xbd, 
		0x42, 0x0e, 0xa5, 0x8c, 0x90, 0x29, 0x6e, 0xee, 
		0x44, 0xfb, 0x4f, 0x7d, 0x9a, 0xdb, 0xca, 0x0a, 
		0xf5, 0x3a, 0xed, 0x49, 0xbc, 0xa2, 0x3a, 0x1f, 
		0xb4, 0x65, 0xb4, 0xde, 0xb7, 0x6a, 0x91, 0x5c, 
		0x3f, 0xa9, 0xd0, 0x9a, 0x2b, 0xda, 0x49, 0x7e, 
		0xf9, 0x2c, 0x53, 0xee, 0x66, 0xcf, 0xc8, 0xbd, 
		0x1e, 0xd1, 0xc1, 0x0e, 0xc2, 0xe4, 0x83, 0x32, 
		0xda, 0x80, 0xc5, 0x9a, 0x1d, 0xf2, 0x8c, 0xc0, 
		0xb1, 0x41, 0x3b, 0xf2, 0x7b, 0xb9, 0x27, 0xfb, 
		0x4f, 0x1b, 0x22, 0xcd, 0x65, 0x07, 0xf4, 0xd1, 
		0x65, 0xf2, 0x98, 0x5d, 0x9f, 0x36, 0x6b, 0x3f, 
		0x90, 0x92, 0x3d, 0x01, 0xf2, 0xb3, 0xa4, 0xf4, 
		0x40, 0x00, 0x4d, 0x73, 0xa6, 0x33, 0xf2, 0x7b, 
		0xc5, 0x8d, 0xd6, 0xc5, 0xc0, 0x01, 0x79, 0x27, 
		0x29, 0xc7, 0xcd, 0xc5, 0x54, 0x62, 0x87, 0x82, 
		0x4b, 0x0e, 0x46, 0xf1, 0xa9, 0xfc, 0x41, 0x76, 
		0xa9, 0x26, 0x02, 0x5f, 0x42, 0x9b, 0x6a, 0x8f, 
		0x77, 0x23, 0x2a, 0xea, 0x31, 0xc9, 0x0d, 0x8d, 
		0x6a, 0x53, 0x93, 0xa4, 0xea, 0xda, 0xdb, 0x53, 
	},
	.e = 0x00000003
};
#else
#error "Must define gs_public_key based on product if CONFIG_GS_SECURE_BOOT enabled"
#endif


/* EOF */
