/*
 * (C) Copyright 2013 Grandstream Networks, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <command.h>
#include <linux/ctype.h>
#include <asm/arch/factory.h>

static char* strtolower(char* str)
{
    static char low[64];
    int i;

    memset( low, 0, sizeof ( low ) );
    for ( i = 0; i < strnlen( str, 63 ); i++ )
        low[i] = tolower(str[i]);

    return low;
}

int do_load_cfg(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    hw_info_t* hw_info = hw_get_hw_feature();

    if ( hw_info == NULL ) {
		printf("do_load_cfg: error -- factory hw_info not available\n");
        return -1;
	}

    setenv( "MODEL", strtolower( hw_info->modelstr ) );
    setenv( "PNSTR", strtolower( hw_get_pn_str() ) );
    if ( hw_info->oem_id != 0 ) {
        setenv( "GSMODEL", strtolower( hw_info->oem_base ) );    
    }
    else {
        setenv( "GSMODEL", strtolower( hw_info->gs_model ) );
    }
    setenv( "CPU", strtolower( hw_info->cpu ) );

    return 0;
}

/**************************************************/
U_BOOT_CMD(
    load_cfg, 1, 1, do_load_cfg, "load config", "\n" 
);

