#ifndef _GS_RSA_H
#define _GS_RSA_H

#define MOD_SIG_LEN 256

struct gs_pubkey_t {
	uint8_t n[256];	
	uint32_t e;
};

extern struct gs_pubkey_t gs_public_key;

int gs_sha256(unsigned char *sha256_digest, unsigned char *buf, unsigned int buflen);

/* gs_rsa_verify
 *
 * return:
 * 0 - verification succeeded
 * !0 - verification failed
 * */
int gs_rsa_verify(unsigned char *sha256_digest, unsigned char *sig, unsigned int siglen);

#endif
