/****************************************************************************
*
* FILENAME:        $RCSfile: toml.c,v $
*
* DESCRIPTION:     toml parser
*
* vi: set ts=4:
*
* Copyright (c) 2018 by Grandstream Networks, Inc.
* All rights reserved.
* 
* This material is proprietary to Grandstream Networks, Inc. and, 
* in addition to the above mentioned Copyright, may be 
* subject to protection under other intellectual property 
* regimes, including patents, trade secrets, designs and/or 
* trademarks. 
*
* Any use of this material for any purpose, except with an 
* express license from Grandstream Networks, Inc. is strictly 
* prohibited. 
*
***************************************************************************/

//=================
//  Includes
//=================

//=================
// Defines
//=================

//=================
//  Globals
//=================

//=================
// Typedefs
//=================
typedef enum {
    TOML_TYPE_ROOT,
    TOML_TYPE_KV,
    TOML_TYPE_TABLE,
} toml_type_t;

struct toml_object;

struct toml_kv {
    struct toml_kv *next;

    char *key;
    int key_len;
    char *value;
    int value_len;
};

struct toml_table {
	char *tag;
    int tag_len;

    struct toml_object *container;
};

struct toml_object {
    struct toml_object *next;
    struct toml_object *parent;
    struct toml_object *children;
    toml_type_t type;
    int array;

    union {
        struct toml_kv toml_kv;
        struct toml_table toml_table;
    } u;
};

//=================
// Functions
//=================
struct toml_object *toml_init( void );
int toml_parse( struct toml_object *root, char *buffer );
void toml_dump( struct toml_object *root );
void toml_free( struct toml_object *root );
